<template>
  <AtomLoader
    v-if="pending"
    class="fr-mx-auto"
  />
  <AtomAlert
    v-else-if="error"
    :alert-type="AlertType.Error"
    message="Les statistiques de la répartion des modes d'hébergement n'ont pas pu être chargées."
  />
  <StatsList
    v-if="accommodationModesStats.length"
    :total-count="beneficiaryCount"
    :stats="accommodationModesStats"
    stats-bar
    :not-filled-route="
      routes.beneficiary.AppBeneficiaries.path({
        notFilled: FilterBeneficiaryNotFilled.BeneficiaryAccommodationMode
      })
    "
  />
  <p v-else>
    Commencez à
    <NuxtLink :to="routes.beneficiary.AppBeneficiariesAdd.path()"
      >créer des fiches de bénéficiaires</NuxtLink
    >
    pour voir apparaître les statistiques de la répartition des modes
    d'hébergement.
  </p>
</template>

<script lang="ts" setup>
  import { StatFilterInput } from '~/server/schema'
  import { AlertType } from '~/utils/constants/alert'
  import { routes } from '~/utils/routes'
  import {
    getStatLabel,
    beneficiaryAccommodationModeKeys
  } from '~/client/options'
  import { FilterBeneficiaryNotFilled } from '~/utils/constants/filters'

  const trpcClient = useTrpcClient()

  const props = defineProps<{
    beneficiaryCount: number
    filters: StatFilterInput
  }>()

  const {
    data: accommodationModesCounts,
    pending,
    error
  } = await trpcClient.stat.getAccommodationModeStats.useQuery(props.filters)

  const accommodationModesStats = computed(
    () =>
      accommodationModesCounts.value?.map(({ _count, accommodationMode }) => ({
        key: accommodationMode || 'null',
        label: getStatLabel(
          beneficiaryAccommodationModeKeys.byKey,
          accommodationMode
        ),
        count: _count
      })) || []
  )
</script>
